<?php 

/**

 * E-Mail-Block 
 * 2005-15-08
 * Version 0.2
 * Technische Fachhochschule (TFH) Berlin 
  * Labor Online Learning
  * http://learn.tfh-berlin.de - ogrimm@tfh-berlin.de
 */

class block_email extends block_base {

	// initialization
    function init() {
        $this->title = "E-Mail";
        $this->content_type = BLOCK_TYPE_TEXT;
        $this->version = 2005081100;
    }
    
	// toggle instantce configuration
	function instance_allow_config() {
    	return true;
	}    
	
	function has_config() {
    	return true;
	}
    
    // generate or collect  required content
    function get_content() {
		global $USER, $CFG, $PAGE;

        $this->course = get_record('course', 'id', $this->instance->pageid);
		
		// detect user role / is this user teacher in this course?
		$teacher = isteacher($this->course->id);

        if($this->content !== NULL) {
            return $this->content;
        }

        $this->content = new stdClass;
        $this->content->footer = '';

	   
		
       	//site level: this block is for administrators only!
        if($this->course->id == 1) {
            if (!isadmin()) {
				$this->content = NULL;	
		    }
		    else {
	        	$this->content->text = $this->get_site_level_content();
	        }
        }

       	// course level: show send mail options depending on admin and course settings        
        else {
       		if (($this->config->block_email_studentsallowed  || $teacher) && $CFG->block_email_studentsallowed) {
       			$this->content->text = $this->get_course_level_content($teacher);
       		}
       		
       		//send mail is not actived by the admin or the user has insufficent permissions so the block shouldn't be displayed
       		else {
				$this->content = NULL;	

		        // ToDo:  Dirty Hack! This is used to run a clean and succesfull self-test of this block on the admin-page...
    	    	if (isadmin())
	    	    	$this->content = "";
       		}
        }     

		return $this->content;
    }
    
    
    function get_course_level_content($teacher) {
   		global $USER, $CFG, $PAGE;

		// Configuration on course level

			$blockcontenttext = '<div id="sendemailblock"><link rel="stylesheet" type="text/css" href="'.$CFG->wwwroot.'/blocks/email/styles.css" />';

			if(($this->config->block_email_allow2all  || $teacher) && $CFG->block_email_allow2all)  {
	
			$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="../email/compose.php?id='.$this->course->id.'&iid='.$this->instance->id.'&sel=all">'.get_string("all_short","email").'</a></div>';
			}
			if(($this->config->block_email_allow2teachers  || $teacher) && $CFG->block_email_allow2teachers){

				$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="../email/compose.php?id='.$this->course->id.'&iid='.$this->instance->id.'&sel=allteachers">'.get_string("allteachers_short","email").'</a></div>';
			}	
			if(($this->config->block_email_allow2students  || $teacher) && $CFG->block_email_allow2students){

				$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="../email/compose.php?id='.$this->course->id.'&iid='.$this->instance->id.'&sel=allstudents">'.get_string("allstudents_short","email").'</a></div>';
			}
			if(($this->config->block_email_allow2selected  || $teacher) && $CFG->block_email_allow2selected){    	

				$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="../email/compose.php?id='.$this->course->id.'&iid='.$this->instance->id.'&sel=select">'.get_string("select_short","email").'</a></div>';
			}
			if(($this->config->block_email_allow2groups  || $teacher) && $CFG->block_email_allow2groups){    	
	
				$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="../email/compose.php?id='.$this->course->id.'&iid='.$this->instance->id.'&sel=group">'.get_string("groups_short","email").'</a></div>';
			}
	
			// Print a hint if the "send mail"-function is unavailable for students
			if(!$this->config->block_email_studentsallowed && $teacher) {
				if(!empty($PAGE)) {
						$blockcontenttext .= '<div class="mailblockhint"><strong><a class="icon edit" title="'. get_string('configuration') .'" href="'.$PAGE->url_get_full(array('instanceid' => $this->instance->id, 'sesskey' => $USER->sesskey)).'&amp;blockaction=config">' .
					                            '<img src="'. $CFG->pixpath .'/t/edit.gif" alt="'.  get_string('configuration') .'" />'. get_string("hint","email") .'</a></strong></div>';
				}
			}
			$blockcontenttext .='</div>';
			
			return $blockcontenttext;

    }
    
    
    /*
    		TODO: Uebersetzungen!
    */
    function get_site_level_content() {
		global $CFG;
		$blockcontenttext = '<div id="sendemailblock"><link rel="stylesheet" type="text/css" href="'.$CFG->wwwroot.'/blocks/email/styles.css" />';
		$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="./email/admin_compose.php?id='.$this->course->id.'&sel=admin_allusers"> '.get_string("admin_allusers","email").'</a></div>';
		$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="./email/admin_compose.php?id='.$this->course->id.'&sel=admin_allteachers"> '.get_string("admin_allteachers","email").'</a></div>';
		$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="./email/admin_compose.php?id='.$this->course->id.'&sel=admin_allcoursecreators"> '.get_string("admin_allcoursecreators","email").' </a></div>';
		$blockcontenttext .= '<div class="mailoption"><img src="'.$CFG->pixpath .'/i/email.gif" alt="Email" width="16" height="16" class="mailpix" /><a href="./email/admin_compose.php?id='.$this->course->id.'&sel=admin_allstudents"> '.get_string("admin_allstudents","email").'</a></div>';
		$blockcontenttext .=' </div>';
		return $blockcontenttext;
 
    }
}

?>







